<html>
<head>
<title>OGRE: Ogre::ShadowCaster Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1ShadowCaster.html">ShadowCaster</a></div>
<h1>Ogre::ShadowCaster Class Reference</h1><!-- doxytag: class="Ogre::ShadowCaster" -->This class defines the interface that must be implemented by shadow casters.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreShadowCaster_8h-source.html">OgreShadowCaster.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for Ogre::ShadowCaster:</div>
<div class="dynsection">
<center><font size="2">[<a href="graph_legend.html">legend</a>]</font></center></div>

<p>
<a href="classOgre_1_1ShadowCaster-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::vector<br>
&lt; <a class="el" href="classOgre_1_1ShadowRenderable.html">ShadowRenderable</a> * &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#c7b3777c0e3521c021ec3a1c2c444039">ShadowRenderableList</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef <br>
<a class="el" href="classOgre_1_1VectorIterator.html">VectorIterator</a><br>
&lt; <a class="el" href="classOgre_1_1ShadowCaster.html#c7b3777c0e3521c021ec3a1c2c444039">ShadowRenderableList</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#7b0999d33e25db97d0449d6cf95cbecd">ShadowRenderableListIterator</a></td></tr>

<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#a09c6e22f9879c123355bca19c1b7131">~ShadowCaster</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#35d47283265f36187263b2738e16c563">getCastShadows</a> (void) const =0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns whether or not this object currently casts a shadow.  <a href="#35d47283265f36187263b2738e16c563"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <a class="el" href="classOgre_1_1EdgeData.html">EdgeData</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#9ec42d43470c2e2b0f6f05221371a786">getEdgeList</a> (void)=0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns details of the edges which might be used to determine a silhouette.  <a href="#9ec42d43470c2e2b0f6f05221371a786"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#99cc616f547693f39fa354e6600368e6">hasEdgeList</a> (void)=0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns whether the object has a valid edge list.  <a href="#99cc616f547693f39fa354e6600368e6"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual const <br>
<a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#6ab7144efe1ca481a4a9a89365ed522d">getWorldBoundingBox</a> (bool derive=false) const =0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the world bounding box of the caster.  <a href="#6ab7144efe1ca481a4a9a89365ed522d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual const <br>
<a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#d792b8137f18ea000c5bcbc5ae48814a">getLightCapBounds</a> (void) const =0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets the world space bounding box of the light cap.  <a href="#d792b8137f18ea000c5bcbc5ae48814a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual const <br>
<a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#aa198e27c2c631a41f8f5f51ad7d7261">getDarkCapBounds</a> (const <a class="el" href="classOgre_1_1Light.html">Light</a> &amp;light, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> dirLightExtrusionDist) const =0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets the world space bounding box of the dark cap, as extruded using the light provided.  <a href="#aa198e27c2c631a41f8f5f51ad7d7261"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <br>
<a class="el" href="classOgre_1_1VectorIterator.html">ShadowRenderableListIterator</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#19cc1a66f375d77f2b4a52c42a0012d4">getShadowVolumeRenderableIterator</a> (<a class="el" href="namespaceOgre.html#79dcd426d291c31072c1ad6f183715d6">ShadowTechnique</a> shadowTechnique, const <a class="el" href="classOgre_1_1Light.html">Light</a> *light, <a class="el" href="classOgre_1_1HardwareIndexBufferSharedPtr.html">HardwareIndexBufferSharedPtr</a> *indexBuffer, bool extrudeVertices, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> extrusionDistance, unsigned long flags=0)=0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets an iterator over the renderables required to render the shadow volume.  <a href="#19cc1a66f375d77f2b4a52c42a0012d4"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#7f8a7e2e3a9876a8453e054335d7d23c">getPointExtrusionDistance</a> (const <a class="el" href="classOgre_1_1Light.html">Light</a> *l) const =0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the distance to extrude for a point/spot light.  <a href="#7f8a7e2e3a9876a8453e054335d7d23c"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#cae2215c051989d544f34083a0a9bfa2">extrudeVertices</a> (const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;vertexBuffer, size_t originalVertexCount, const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;lightPos, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> extrudeDist)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Utility method for extruding vertices based on a light.  <a href="#cae2215c051989d544f34083a0a9bfa2"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#233233e14ccb869b6cafd655880355df">getExtrusionDistance</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;objectPos, const <a class="el" href="classOgre_1_1Light.html">Light</a> *light) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Helper moethod for calculating extrusion distance.  <a href="#233233e14ccb869b6cafd655880355df"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#c9a881430ec7769923f63f6df4b93d33">updateEdgeListLightFacing</a> (<a class="el" href="classOgre_1_1EdgeData.html">EdgeData</a> *edgeData, const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;lightPos)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Tells the caster to perform the tasks necessary to update the edge data's light listing.  <a href="#c9a881430ec7769923f63f6df4b93d33"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#396374525d65e0db10c7f7f8d380744a">generateShadowVolume</a> (<a class="el" href="classOgre_1_1EdgeData.html">EdgeData</a> *edgeData, const <a class="el" href="classOgre_1_1HardwareIndexBufferSharedPtr.html">HardwareIndexBufferSharedPtr</a> &amp;indexBuffer, const <a class="el" href="classOgre_1_1Light.html">Light</a> *light, <a class="el" href="classOgre_1_1ShadowCaster.html#c7b3777c0e3521c021ec3a1c2c444039">ShadowRenderableList</a> &amp;shadowRenderables, unsigned long flags)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Generates the indexes required to render a shadow volume into the index buffer which is passed in, and updates shadow renderables to use it.  <a href="#396374525d65e0db10c7f7f8d380744a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#136dfd54b581a6dc58a1796a1cdf6cdc">extrudeBounds</a> (<a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;box, const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;lightPos, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> extrudeDist) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Utility method for extruding a bounding box.  <a href="#136dfd54b581a6dc58a1796a1cdf6cdc"></a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
This class defines the interface that must be implemented by shadow casters. 
<p>Definition at line <a class="el" href="OgreShadowCaster_8h-source.html#l00108">108</a> of file <a class="el" href="OgreShadowCaster_8h-source.html">OgreShadowCaster.h</a>.</p>
<hr><h2>Member Typedef Documentation</h2>
<a class="anchor" name="c7b3777c0e3521c021ec3a1c2c444039"></a><!-- doxytag: member="Ogre::ShadowCaster::ShadowRenderableList" ref="c7b3777c0e3521c021ec3a1c2c444039" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;<a class="el" href="classOgre_1_1ShadowRenderable.html">ShadowRenderable</a>*&gt; <a class="el" href="classOgre_1_1ShadowCaster.html#c7b3777c0e3521c021ec3a1c2c444039">Ogre::ShadowCaster::ShadowRenderableList</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreShadowCaster_8h-source.html#l00127">127</a> of file <a class="el" href="OgreShadowCaster_8h-source.html">OgreShadowCaster.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="7b0999d33e25db97d0449d6cf95cbecd"></a><!-- doxytag: member="Ogre::ShadowCaster::ShadowRenderableListIterator" ref="7b0999d33e25db97d0449d6cf95cbecd" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="classOgre_1_1VectorIterator.html">VectorIterator</a>&lt;<a class="el" href="classOgre_1_1ShadowCaster.html#c7b3777c0e3521c021ec3a1c2c444039">ShadowRenderableList</a>&gt; <a class="el" href="classOgre_1_1VectorIterator.html">Ogre::ShadowCaster::ShadowRenderableListIterator</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreShadowCaster_8h-source.html#l00128">128</a> of file <a class="el" href="OgreShadowCaster_8h-source.html">OgreShadowCaster.h</a>.</p>

</div>
</div><p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="a09c6e22f9879c123355bca19c1b7131"></a><!-- doxytag: member="Ogre::ShadowCaster::~ShadowCaster" ref="a09c6e22f9879c123355bca19c1b7131" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual Ogre::ShadowCaster::~ShadowCaster           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreShadowCaster_8h-source.html#l00111">111</a> of file <a class="el" href="OgreShadowCaster_8h-source.html">OgreShadowCaster.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="35d47283265f36187263b2738e16c563"></a><!-- doxytag: member="Ogre::ShadowCaster::getCastShadows" ref="35d47283265f36187263b2738e16c563" args="(void) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool Ogre::ShadowCaster::getCastShadows           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns whether or not this object currently casts a shadow. 
<p>

<p>Implemented in <a class="el" href="classOgre_1_1MovableObject.html#70bca10cdeac93142d9f93ed0cf9c4c5">Ogre::MovableObject</a>.</p>

</div>
</div><p>
<a class="anchor" name="9ec42d43470c2e2b0f6f05221371a786"></a><!-- doxytag: member="Ogre::ShadowCaster::getEdgeList" ref="9ec42d43470c2e2b0f6f05221371a786" args="(void)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1EdgeData.html">EdgeData</a>* Ogre::ShadowCaster::getEdgeList           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns details of the edges which might be used to determine a silhouette. 
<p>

<p>Implemented in <a class="el" href="classOgre_1_1Entity.html#b3d3d4e4aef1e2831572c2c052d29aec">Ogre::Entity</a>, <a class="el" href="classOgre_1_1ManualObject.html#5a53798ccf0c34105122ee77dad0904d">Ogre::ManualObject</a>, <a class="el" href="classOgre_1_1MovableObject.html#60b24cd45c8df45654dcfa14a1293a3b">Ogre::MovableObject</a>, and <a class="el" href="classOgre_1_1StaticGeometry_1_1Region.html#111ad7217f020df5a38f8d218b7803c0">Ogre::StaticGeometry::Region</a>.</p>

</div>
</div><p>
<a class="anchor" name="99cc616f547693f39fa354e6600368e6"></a><!-- doxytag: member="Ogre::ShadowCaster::hasEdgeList" ref="99cc616f547693f39fa354e6600368e6" args="(void)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool Ogre::ShadowCaster::hasEdgeList           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns whether the object has a valid edge list. 
<p>

<p>Implemented in <a class="el" href="classOgre_1_1Entity.html#f155dfe2635fad3ed2aff25fcde75421">Ogre::Entity</a>, <a class="el" href="classOgre_1_1ManualObject.html#77b98b65fbf51b3b611b4e423c74fe79">Ogre::ManualObject</a>, <a class="el" href="classOgre_1_1MovableObject.html#b7c2a8be6a9bd59e6c69ee2d76945500">Ogre::MovableObject</a>, and <a class="el" href="classOgre_1_1StaticGeometry_1_1Region.html#5ff65b3d2928d260e96535cff3ce2ffb">Ogre::StaticGeometry::Region</a>.</p>

</div>
</div><p>
<a class="anchor" name="6ab7144efe1ca481a4a9a89365ed522d"></a><!-- doxytag: member="Ogre::ShadowCaster::getWorldBoundingBox" ref="6ab7144efe1ca481a4a9a89365ed522d" args="(bool derive=false) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a>&amp; Ogre::ShadowCaster::getWorldBoundingBox           </td>
          <td>(</td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>derive</em> = <code>false</code>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get the world bounding box of the caster. 
<p>

<p>Implemented in <a class="el" href="classOgre_1_1Entity.html#5edde0278ae3942c9816690cb3462853">Ogre::Entity</a>, and <a class="el" href="classOgre_1_1MovableObject.html#cc31c877990c3c231c4b4cfb0522bef8">Ogre::MovableObject</a>.</p>

</div>
</div><p>
<a class="anchor" name="d792b8137f18ea000c5bcbc5ae48814a"></a><!-- doxytag: member="Ogre::ShadowCaster::getLightCapBounds" ref="d792b8137f18ea000c5bcbc5ae48814a" args="(void) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a>&amp; Ogre::ShadowCaster::getLightCapBounds           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets the world space bounding box of the light cap. 
<p>

<p>Implemented in <a class="el" href="classOgre_1_1MovableObject.html#f061175eb50a6aa98599ce0a748204b5">Ogre::MovableObject</a>.</p>

</div>
</div><p>
<a class="anchor" name="aa198e27c2c631a41f8f5f51ad7d7261"></a><!-- doxytag: member="Ogre::ShadowCaster::getDarkCapBounds" ref="aa198e27c2c631a41f8f5f51ad7d7261" args="(const Light &amp;light, Real dirLightExtrusionDist) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a>&amp; Ogre::ShadowCaster::getDarkCapBounds           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>dirLightExtrusionDist</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets the world space bounding box of the dark cap, as extruded using the light provided. 
<p>

<p>Implemented in <a class="el" href="classOgre_1_1MovableObject.html#f06612d0607ebcf1bf5eb817c3038d52">Ogre::MovableObject</a>.</p>

</div>
</div><p>
<a class="anchor" name="19cc1a66f375d77f2b4a52c42a0012d4"></a><!-- doxytag: member="Ogre::ShadowCaster::getShadowVolumeRenderableIterator" ref="19cc1a66f375d77f2b4a52c42a0012d4" args="(ShadowTechnique shadowTechnique, const Light *light, HardwareIndexBufferSharedPtr *indexBuffer, bool extrudeVertices, Real extrusionDistance, unsigned long flags=0)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1VectorIterator.html">ShadowRenderableListIterator</a> Ogre::ShadowCaster::getShadowVolumeRenderableIterator           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#79dcd426d291c31072c1ad6f183715d6">ShadowTechnique</a>&nbsp;</td>
          <td class="paramname"> <em>shadowTechnique</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> *&nbsp;</td>
          <td class="paramname"> <em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareIndexBufferSharedPtr.html">HardwareIndexBufferSharedPtr</a> *&nbsp;</td>
          <td class="paramname"> <em>indexBuffer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>extrudeVertices</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>extrusionDistance</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned long&nbsp;</td>
          <td class="paramname"> <em>flags</em> = <code>0</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets an iterator over the renderables required to render the shadow volume. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Shadowable geometry should ideally be designed such that there is only one <a class="el" href="classOgre_1_1ShadowRenderable.html" title="Class which represents the renderable aspects of a set of shadow volume faces.">ShadowRenderable</a> required to render the the shadow; however this is not a necessary limitation and it can be exceeded if required. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>shadowTechnique</em>&nbsp;</td><td>The technique being used to generate the shadow </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>light</em>&nbsp;</td><td>The light to generate the shadow from </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>indexBuffer</em>&nbsp;</td><td>The index buffer to build the renderables into, the current contents are assumed to be disposable. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>extrudeVertices</em>&nbsp;</td><td>If true, this means this class should extrude the vertices of the back of the volume in software. If false, it will not be done (a vertex program is assumed). </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>extrusionDistance</em>&nbsp;</td><td>The distance to extrude the shadow volume </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>flags</em>&nbsp;</td><td>Technique-specific flags, see ShadowRenderableFlags </td></tr>
  </table>
</dl>

<p>Implemented in <a class="el" href="classOgre_1_1Entity.html#5c2c5a1d7923238f10b78c030c57a5ea">Ogre::Entity</a>, <a class="el" href="classOgre_1_1ManualObject.html#e76e83dd4c4c61f2428d1b78fa40824d">Ogre::ManualObject</a>, <a class="el" href="classOgre_1_1MovableObject.html#4492fa817bb3a750d349aeec34c19c43">Ogre::MovableObject</a>, and <a class="el" href="classOgre_1_1StaticGeometry_1_1Region.html#c0d6ab629e47ee3bb10f87f65930c885">Ogre::StaticGeometry::Region</a>.</p>

</div>
</div><p>
<a class="anchor" name="cae2215c051989d544f34083a0a9bfa2"></a><!-- doxytag: member="Ogre::ShadowCaster::extrudeVertices" ref="cae2215c051989d544f34083a0a9bfa2" args="(const HardwareVertexBufferSharedPtr &amp;vertexBuffer, size_t originalVertexCount, const Vector4 &amp;lightPos, Real extrudeDist)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void Ogre::ShadowCaster::extrudeVertices           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>vertexBuffer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>originalVertexCount</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>lightPos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>extrudeDist</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Utility method for extruding vertices based on a light. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Unfortunately, because D3D cannot handle homogenous (4D) position coordinates in the fixed-function pipeline (GL can, but we have to be cross-API), when we extrude in software we cannot extrude to infinity the way we do in the vertex program (by setting w to 0.0f). Therefore we extrude by a fixed distance, which may cause some problems with larger scenes. Luckily better hardware (ie vertex programs) can fix this. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>vertexBuffer</em>&nbsp;</td><td>The vertex buffer containing ONLY xyz position values, which must be originalVertexCount * 2 * 3 floats long. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>originalVertexCount</em>&nbsp;</td><td>The count of the original number of vertices, ie the number in the mesh, not counting the doubling which has already been done (by <a class="el" href="classOgre_1_1VertexData.html#35751c0e63acf6def8a1cf101abd1b28" title="Modifies the vertex data to be suitable for use for rendering shadow geometry.">VertexData::prepareForShadowVolume</a>) to provide the extruded area of the buffer. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>lightPos</em>&nbsp;</td><td>4D light position in object space, when w=0.0f this represents a directional light </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>extrudeDist</em>&nbsp;</td><td>The distance to extrude </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="7f8a7e2e3a9876a8453e054335d7d23c"></a><!-- doxytag: member="Ogre::ShadowCaster::getPointExtrusionDistance" ref="7f8a7e2e3a9876a8453e054335d7d23c" args="(const Light *l) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> Ogre::ShadowCaster::getPointExtrusionDistance           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> *&nbsp;</td>
          <td class="paramname"> <em>l</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get the distance to extrude for a point/spot light. 
<p>

<p>Implemented in <a class="el" href="classOgre_1_1MovableObject.html#bb13b8e1b52d9dca9f5190f718686a5e">Ogre::MovableObject</a>.</p>

</div>
</div><p>
<a class="anchor" name="233233e14ccb869b6cafd655880355df"></a><!-- doxytag: member="Ogre::ShadowCaster::getExtrusionDistance" ref="233233e14ccb869b6cafd655880355df" args="(const Vector3 &amp;objectPos, const Light *light) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> Ogre::ShadowCaster::getExtrusionDistance           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>objectPos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> *&nbsp;</td>
          <td class="paramname"> <em>light</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Helper moethod for calculating extrusion distance. 
<p>

</div>
</div><p>
<a class="anchor" name="c9a881430ec7769923f63f6df4b93d33"></a><!-- doxytag: member="Ogre::ShadowCaster::updateEdgeListLightFacing" ref="c9a881430ec7769923f63f6df4b93d33" args="(EdgeData *edgeData, const Vector4 &amp;lightPos)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::ShadowCaster::updateEdgeListLightFacing           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1EdgeData.html">EdgeData</a> *&nbsp;</td>
          <td class="paramname"> <em>edgeData</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>lightPos</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Tells the caster to perform the tasks necessary to update the edge data's light listing. 
<p>
Can be overridden if the subclass needs to do additional things. <dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>edgeData</em>&nbsp;</td><td>The edge information to update </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>lightPos</em>&nbsp;</td><td>4D vector representing the light, a directional light has w=0.0 </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="396374525d65e0db10c7f7f8d380744a"></a><!-- doxytag: member="Ogre::ShadowCaster::generateShadowVolume" ref="396374525d65e0db10c7f7f8d380744a" args="(EdgeData *edgeData, const HardwareIndexBufferSharedPtr &amp;indexBuffer, const Light *light, ShadowRenderableList &amp;shadowRenderables, unsigned long flags)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::ShadowCaster::generateShadowVolume           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1EdgeData.html">EdgeData</a> *&nbsp;</td>
          <td class="paramname"> <em>edgeData</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1HardwareIndexBufferSharedPtr.html">HardwareIndexBufferSharedPtr</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>indexBuffer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> *&nbsp;</td>
          <td class="paramname"> <em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ShadowCaster.html#c7b3777c0e3521c021ec3a1c2c444039">ShadowRenderableList</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>shadowRenderables</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned long&nbsp;</td>
          <td class="paramname"> <em>flags</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Generates the indexes required to render a shadow volume into the index buffer which is passed in, and updates shadow renderables to use it. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>edgeData</em>&nbsp;</td><td>The edge information to use </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>indexBuffer</em>&nbsp;</td><td>The buffer into which to write data into; current contents are assumed to be discardable. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>light</em>&nbsp;</td><td>The light, mainly for type info as silhouette calculations should already have been done in updateEdgeListLightFacing </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>shadowRenderables</em>&nbsp;</td><td>A list of shadow renderables which has already been constructed but will need populating with details of the index ranges to be used. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>flags</em>&nbsp;</td><td>Additional controller flags, see ShadowRenderableFlags </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="136dfd54b581a6dc58a1796a1cdf6cdc"></a><!-- doxytag: member="Ogre::ShadowCaster::extrudeBounds" ref="136dfd54b581a6dc58a1796a1cdf6cdc" args="(AxisAlignedBox &amp;box, const Vector4 &amp;lightPos, Real extrudeDist) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::ShadowCaster::extrudeBounds           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>box</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>lightPos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>extrudeDist</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Utility method for extruding a bounding box. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>box</em>&nbsp;</td><td>Original bounding box, will be updated in-place </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>lightPos</em>&nbsp;</td><td>4D light position in object space, when w=0.0f this represents a directional light </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>extrudeDist</em>&nbsp;</td><td>The distance to extrude </td></tr>
  </table>
</dl>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreShadowCaster_8h-source.html">OgreShadowCaster.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:53:38 2008
</p>
</body>
</html>
